<template lang="pug">
  div.discord.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row( justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          div(v-if="success")
            el-row(justify="center" type="flex")
              p #[i.bx.bxl-discord-alt] Success!
            el-row(justify="center" type="flex")
              p Welcome!
            el-row(justify="center" type="flex")
              el-row(justify="center" align="middle" type="flex")
                el-avatar(:src="getAvatar()")
                el-tag(type="primary") {{user.username}}\#{{user.discriminator}}
            el-row(justify="center" type="flex")
              p Sending you to your dashboard in a moment...
          div(v-else-if="code && state && valid")
            el-row(justify="center" type="flex")
              p #[i.bx.bxl-discord-alt] Processing...
            el-row(justify="center" type="flex")
              p(v-loading="loading" element-loading-background="rgba(255, 255, 255, 0.75)" @click="changeQuote()") {{quote}}
            el-row(justify="center" type="flex")
              p Please wait while we finish logging you in...
          div(v-else-if="error && errorDescription")
            el-row(justify="center" type="flex")
              p #[i.bx.bx-error] {{error.replace('_', ' ').toUpperCase()}}
            el-row(justify="center" type="flex")
              p {{errorDescription}}.
            el-row(justify="center" type="flex")
              p Our satelite seems to have been ground-pounded, care to try again?
          div(v-else)
            el-row(justify="center" type="flex")
              p #[i.bx.bx-error] Nope...
            el-row(justify="center" type="flex")
              p Something's not right here, we're missing info from Discord, please try again.
          el-divider {{valid ? 'Taking too long?' : 'Try again...'}}
          el-row(justify="center" type="flex")
            NuxtLink(v-if="success" to="/dashboard") #[el-button(type="primary") #[i.bx.bxs-dashboard] Dashboard]
            NuxtLink(v-else to="/") #[el-button(type="primary") #[i.bx.bx-home] Go Home]
          el-row(v-if="dev")
            el-divider Dev
            el-row(justify="left" type="flex")
              p Code: #[span.highlight {{code ? code : 'No code provided!'}}]
            el-row(justify="left" type="flex")
              p State: #[span.highlight {{state ? state : 'No state provided!'}}]
            el-row(justify="left" type="flex")
              p Token: #[span.highlight {{token ? token : 'No token provided!'}}]
            el-row(justify="center" type="flex")
              el-tag(:type="valid ? 'success' : 'danger'") {{valid ? 'Totally Valid' : 'Not Valid'}}
</template>

<script lang="ts">
import Vue from 'vue'

import Easter from '@/middleware/easter'

const easter = new Easter()

function getQuote () {
  const quoter = easter.pick()
  let text = quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]
  text = `${quoter.icon} ${text}`
  return text
}

async function handleOAuth (code: string, token: string) {
  const api = '/api/v1/oauth'
  return await fetch(api, {
    method: 'POST',
    headers: {
      Authorization: token,
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    body: `code=${code}`
  })
}

async function getUser (token: string) {
  const api = '/api/v1/user'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

export default Vue.extend({
  data () {
    const token = window.localStorage.getItem('coco_token')
    const code = this.$route.query.code
    const state = this.$route.query.state
    return {
      dev: false,
      loading: true,
      code,
      success: false,
      state,
      token,
      valid: code && state && token && token === state,
      error: this.$route.query.error,
      errorDescription: this.$route.query.error_description,
      quote: getQuote(),
      user: null
    }
  },
  async mounted () {
    if (typeof (this.code) === 'string' && typeof (this.token) === 'string') {
      const resp = await handleOAuth(this.code, this.token)
      if (resp.status === 201) {
        const user = await getUser(this.token)
        this.user = await user.json()
        this.loading = false
        this.success = true
        window.location.href = '/dashboard'
      } else {
        this.loading = false
        this.valid = false
        this.error = 'auth failure'
        this.errorDescription = 'Login failed, please try again'
      }
    }
  },
  methods: {
    changeQuote () {
      this.quote = getQuote()
    },
    getAvatar (): string {
      const user = this.user as any
      const ext = user.avatar.indexOf('a_') === 0 ? 'gif' : 'png'
      return `https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}.${ext}`
    }
  }
})
</script>
